clear;clc
%% Parameter of Subsystem
Kr=0.993e-3; % mol (s A)^-1
KH2=0.843;  % mol (s atm)^1
KH2O=0.281; % mol (s atm)^1
KO2=2.52;  % mol (s atm)^1

tauH2=26.1;   % seconds
tauH2O=78.3;  % seconds
tauO2=2.91;   % seconds
%% Parameter of Methanol reformer
N=384; %Number of cells in stack
F=96486; % c/mol
U=0.8;
CV=2;
tau1=4; % Or 2
tau2=4; % Or 2
tau3=4;
k3=1/(2*CV);
rH2O=1.145; % Or 1.168;
tauf=5;
Ifc_0=300;%0e3/330;%.15e3;
%% Initial parameters
qH2_0=Ifc_0*N/(2*F*U);
pH2_0=1/KH2*(qH2_0-2*Kr*Ifc_0);
pH2O_0=1/KH2O*2*Kr*Ifc_0;
pO2_0=1/KO2*(1/rH2O*qH2_0-Kr*Ifc_0);
V=312.4%V
%% Parameter of Loss
ka1=53.5041;
ka2=65000/8.314;
iL=0.8e3;
gam=0.2;
beta=-2870;
T0=973;
A=101.2e3; %A/cm^2
Eact=120e3; % J/mol
%% Parameter of Thermal Block
eta=0.8;
heff=10e-3;
lamda=2;
dt=200;
ro=6600;
cp=400;
%% Parameter of Nernest Voltage
E=1.1;%0.935;
R=8314.47e-3;
VNernst_0=N*R*T0/2/F*log(pH2_0*sqrt(pO2_0)/pH2O_0)+E*N;
%%
A1=69.20001;
B1=8.548290;
C1=-0.862921;
D1=0.246374;
E1=-1.382767;
%%
fuz=readfis('I:\½ļ\Final\SOFCFuzzyPID4.fis');
%fuz=readfis('F:\½ļ\Final\SOFCFuzzyPID4.fis');
set(gca,'FontSize',22);
figure(1);
subplot(121);
plotmf(fuz,'input',1);
subplot(122);
plotmf(fuz,'input',2);
figure(2);
subplot(121);
plotmf(fuz,'output',1);
subplot(122);
plotmf(fuz,'output',2);

%%
syms s
tf1=(2.417*s + 0.8276)/(s^3 + 0.716*s^2 + 0.1808*s + 0.006914)
%% Picture
figure(1);
subplot(2,1,1);
plot(t-50,y1,'r',t-50,y2,'b-.',t-50,r1,'k--','LineWidth',2);
xlim([0 650]);
ylim([280 380]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Voltage(V)','fontsize',22,'color','k');
hold on;
subplot(2,1,2);
plot(t-50,I1,'b','LineWidth',2);
xlim([0 650]);
ylim([280 320]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Current(A)','fontsize',22,'color','k');

figure(2);
subplot(2,1,1);
plot(t-50,u1,'r',t-50,u2,'b-.','LineWidth',2);
xlim([0 650]);
ylim([0 2]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Fuel Flow(mol/s)','fontsize',22,'color','k');
subplot(2,1,2);
plot(t-50,uf1,'r',t-50,uf2,'b-.','LineWidth',2);
xlim([0 650]);
ylim([0.1 1.1]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Utilization','fontsize',22,'color','k');

figure(3)
subplot(2,1,1);
plot(t-50,Kp,'b','LineWidth',2)
xlim([0 650]);
set(gca,'FontSize',22);
xlabel('Time(s)','fontsize',22,'color','k');
ylabel('Kp','fontsize',22,'color','k');
subplot(2,1,2);
plot(t-50,Ki,'b','LineWidth',2);
xlim([0 650]);
ylim([-0.15 0.15]);
set(gca,'FontSize',22);
xlabel('Time(s)','fontsize',22,'color','k');
ylabel('Ki','fontsize',22,'color','k');

%%
figure(1);
subplot(2,1,1);
plot(t-50,y1,'r',t-50,y2,'b-.',t-50,r1,'k--','LineWidth',2);
xlim([0 350]);
ylim([280 330]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Voltage(V)','fontsize',22,'color','k');
subplot(2,1,2);
plot(t-50,I1,'b','LineWidth',2);
xlim([0 350]);
ylim([200 700]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Current(A)','fontsize',22,'color','k');

figure(2);
subplot(2,1,1);
plot(t-50,u1,'r',t-50,u2,'b-.','LineWidth',2);
xlim([0 350]);
ylim([0 2]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Fuel Flow(mol/s)','fontsize',22,'color','k');
subplot(2,1,2);
plot(t-50,uf1,'r',t-50,uf2,'b-.','LineWidth',2);
xlim([0 350]);
ylim([0.5 1.1]);
set(gca,'FontSize',22);
xlabel('Time(sec)','fontsize',22,'color','k');
ylabel('Utilization','fontsize',22,'color','k');

figure(3)
subplot(2,1,1);
plot(t-50,Kp,'b','LineWidth',2)
xlim([0 350]);
set(gca,'FontSize',22);
xlabel('Time(s)','fontsize',22,'color','k');
ylabel('Kp','fontsize',22,'color','k');
subplot(2,1,2);
plot(t-50,Ki,'b','LineWidth',2);
xlim([0 350]);
ylim([-0.15 0.15]);
set(gca,'FontSize',22);
xlabel('Time(s)','fontsize',22,'color','k');
ylabel('Ki','fontsize',22,'color','k');
%%
%% Picture
figure(1);
subplot(2,1,1);
plot(t-50,y1,'b',t-50,y2,'r-.',t-50,r1,'k:','LineWidth',2);
xlim([0 650]);
ylim([280 380]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('ѹ(V)','fontsize',25,'color','k');
hold on;
subplot(2,1,2);
plot(t-50,I1,'b','LineWidth',2);
xlim([0 650]);
ylim([280 320]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('(A)','fontsize',25,'color','k');

figure(2);
subplot(2,1,1);
plot(t-50,u1,'b',t-50,u2,'r-.','LineWidth',2);
xlim([0 650]);
ylim([0 2]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('(mol/s)','fontsize',25,'color','k');
subplot(2,1,2);
plot(t-50,uf1,'b',t-50,uf2,'r-.','LineWidth',2);
xlim([0 650]);
ylim([0.1 1.1]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('ȼϵ','fontsize',25,'color','k');

figure(3)
subplot(2,1,1);
plot(t-50,Kp,'b','LineWidth',2)
xlim([0 650]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('Kp','fontsize',25,'color','k');
subplot(2,1,2);
plot(t-50,Ki,'b','LineWidth',2);
xlim([0 650]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('Ki','fontsize',25,'color','k');

%%
figure(1);
subplot(2,1,1);
plot(t-50,y1,'b',t-50,y2,'r-.',t-50,r1,'k:','LineWidth',2);
xlim([0 350]);
ylim([280 330]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('ѹ(V)','fontsize',25,'color','k');
hold on;
subplot(2,1,2);
plot(t-50,I1,'b','LineWidth',2);
xlim([0 350]);
ylim([200 700]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('(A)','fontsize',25,'color','k');

figure(2);
subplot(2,1,1);
plot(t-50,u1,'b',t-50,u2,'r-.','LineWidth',2);
xlim([0 350]);
ylim([0 2]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('(mol/s)','fontsize',25,'color','k');
subplot(2,1,2);
plot(t-50,uf1,'b',t-50,uf2,'r-.','LineWidth',2);
xlim([0 350]);
ylim([0.5 1.1]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('ȼϵ','fontsize',25,'color','k');

figure(3)
subplot(2,1,1);
plot(t-50,Kp,'b','LineWidth',2)
xlim([0 350]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('Kp','fontsize',25,'color','k');
subplot(2,1,2);
plot(t-50,Ki,'b','LineWidth',2);
xlim([0 350]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('Ki','fontsize',25,'color','k');
%%
figure(1)
subplot(2,1,1);
plot(t-50,Kp,'r-.',t-50,Ki,'b','LineWidth',2);
xlim([0 350]);
ylim([-0.2 0.4]);
set(gca,'FontSize',25);
xlabel('ʱ(s)','fontsize',25,'color','k');
ylabel('ϵ','fontsize',25,'color','k');